package imagemed.layout.validator;

public class DefaultschFacilityValidator extends DBValidator {

	@Override
	protected void preValidate() {
		setMandatoryError( "0FNA" );

		//set Days Operating from/to non-editable if device is not operating on that day
		/*		
				String operatingDays = getValue( "0FOD" );
				if( operatingDays != null ) {
					if( operatingDays.indexOf( '1' ) == -1 ) {
						setNonEditable( "0FF1" );
						setNonEditable( "0FT1" );
					}
					if( operatingDays.indexOf( '2' ) == -1 ) {
						setNonEditable( "0FF2" );
						setNonEditable( "0FT2" );
					}
					if( operatingDays.indexOf( '3' ) == -1 ) {
						setNonEditable( "0FF3" );
						setNonEditable( "0FT3" );
					}
					if( operatingDays.indexOf( '4' ) == -1 ) {
						setNonEditable( "0FF4" );
						setNonEditable( "0FT4" );
					}
					if( operatingDays.indexOf( '5' ) == -1 ) {
						setNonEditable( "0FF5" );
						setNonEditable( "0FT5" );
					}
					if( operatingDays.indexOf( '6' ) == -1 ) {
						setNonEditable( "0FF6" );
						setNonEditable( "0FT6" );
					}
					if( operatingDays.indexOf( '7' ) == -1 ) {
						setNonEditable( "0FF7" );
						setNonEditable( "0FT7" );
					}
				}
		*/

		//Refresh - Set fields
		String refreshingType = getRefreshType();

		if ( REFRESHTYPE_FIELDCHANGE.equals( refreshingType ) ) {
			String refreshingColid = getRefreshingColid();

			//Operating From -> days Operating From
			if ( "0FOF".equals( refreshingColid ) ) {
				String[][] colids = { { "0FOF", "0FF1" }, { "0FOF", "0FF2" }, { "0FOF", "0FF3" }, { "0FOF", "0FF4" }, { "0FOF", "0FF5" }, { "0FOF", "0FF6" }, { "0FOF", "0FF7" } };
				copyValues( colids, null, null );
			}

			//Operating To -> days Operating To
			if ( "0FOT".equals( refreshingColid ) ) {
				String[][] colids = { { "0FOT", "0FT1" }, { "0FOT", "0FT2" }, { "0FOT", "0FT3" }, { "0FOT", "0FT4" }, { "0FOT", "0FT5" }, { "0FOT", "0FT6" }, { "0FOT", "0FT7" } };
				copyValues( colids, null, null );
			}

		}

	}

	@Override
	public void validate() {

		setPrimaryWarning( new String[]{ "0FNA" } );
	}


}
