<%@
  page errorPage ="../main/exceptionHandler.jsp"

%><%@

  page import="imagemed.imsession.*, imagemed.jsputil.*,imagemed.util.*,java.util.*, java.text.Format"

%><%!
public static String getImageComboBox(IMSession is, String prefix, Set<String> extensions, String ext, String folder) {
	boolean empty =true;
	StringBuffer result = new StringBuffer("");
	String[] fileNames;
	
	if( folder == null ) {
		fileNames = AttachmentManager.getAdminNames();
	}
	else {
		fileNames = Helper.getDirectoryContentAsStringArray(folder);
		Helper.DEBUG( "getImageComboBox", "folder:" + folder + " filename" + fileNames.toString() );
	}
	fileNames = Helper.sortCaseInSensitive(fileNames);
	result.append(prefix + "<select size=10 name=\"c"+ext+"Name\" id=\"select_"+ext+"\" onChange='adjustOpen(\""+ext+"\")'>\n");
	prefix = LayoutXmlToolbox.indent(prefix);
	for (int i=0; i<fileNames.length; i++) {
		Helper.DEBUG( "getImageComboBox", "filename:" + fileNames[i] );
		try {
			String extension = fileNames[i].substring(fileNames[i].lastIndexOf(".")+1);
			if ((extensions != null && extensions.contains(extension.toLowerCase())) || ext.equals(extension)) {
				result.append(prefix + "<option value=\""+fileNames[ i ]+"\" selected>"+fileNames[ i ]+"\n");
				empty=false;
			}
		}
		catch (Throwable th) {}
	}
	prefix = LayoutXmlToolbox.unIndent(prefix);
	result.append(prefix + "</select>\n");
	if (!empty) {
		return result.toString();
	}
	return null;
}

public static boolean printSection(IMSession is, String ext, Set<String> extensions, String label) throws IOException {
	String imageCombo;
	if (label == null) {
		//label = ext.toUpperCase()+" documents on server";
		label = LocalizedMessage.getCompoundMessage( "CASES_BROWSEDOCUMENTS_EXT_ON_SERVER", new Format[] { null }, new Object[] { ext.toUpperCase() }, true );
	}
	String folder = null;
	if( "xml".equals( ext ) ) {
		folder = LayoutCache.getXmlDir( LayoutPart.SCHPRINTLAYOUT );
	}
	imageCombo = getImageComboBox(is, "          ", extensions, ext, folder );
	boolean isEmpty = (imageCombo == null);
	if (!isEmpty) {
		is.out.println("			<tr>");
		is.out.println("				<td valign=center nowrap>");
		is.out.println("				  <br>&nbsp;&nbsp;"+label+": <br>&nbsp;");
		is.out.println("				</td>");
		is.out.println("				<td valign=center nowrap>");
		is.out.println("					"+imageCombo+"&nbsp;");
		is.out.println("				</td>");
		is.out.println("				<td valign=center nowrap>");
		is.out.println("					<a href=\"\" id=\"link_"+ext+"\">");
		is.out.println("						"+JSHelper.getJsButton(is, "openButton", 24, 24, LocalizedMessage.getSimpleMessage( "ALT_TEXT_OPEN_DOC" )));
		is.out.println("					</a>&nbsp;&nbsp;&nbsp;");
		is.out.println("          <script language=javascript>adjustOpen(\""+ext+"\");</script>");
		is.out.println("				</td>");
		//server side printing - if possible
		if( "jpg".equals( ext ) ||
				"pdf".equals( ext ) ||
				"xml".equals( ext ) ) {
			is.out.println("				<td valign=center nowrap>");
			is.out.println("					<A href='#' onClick=adjustedPrint(\"" + ext + "\",\"" + AttachmentManager.getAdminDir() + "\") >");
			is.out.println("						"+JSHelper.getJsButton ( is, "printServer", LocalizedMessage.getCompoundMessage( "ALT_TEXT_PRINT_ON_X", new Format[] { null }, new Object[] { AttachmentManager.getPrinterInfoOnButton( is ) }, false ) ) );
			is.out.println("					</a>&nbsp;&nbsp;&nbsp;");
			is.out.println("				</td>");
		}
		is.out.println("			</tr>");
	}
	return isEmpty;
}



%><%IMSession is = new IMSession(request, response, out); 
  if (!is.regOK()) {
    return;
  }

  if (is.regID == null) { //Log time-out
    return;
  }%><%-- -----HTML---- --%><%@page import="java.io.IOException"%>
<%@page import="imagemed.layout.LayoutPart"%>
<%@page import="java.io.File"%>
<%@page import="imagemed.layout.cache.LayoutCache"%>

<%@page import="imagemed.types.flag.IMTypeur"%><HTML>
<HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_BROWSEDOCUMENTS_PAGE" ) %></TITLE>
<%
	imagemed.tables.Table.printCommonScript(is);
	JSHelper.printJsInclude( out, JSHelper.IMPOPUP_JS );
%>
	<script language="JavaScript">
	
function my_getelementbyid(id) {
	if (document.getElementById) {
		return document.getElementById(id);
	}
	else if (document.all) {
		return document.all[id];
	}
	else if (document.layers) {
		return document.layers[id];
	}
	else {
		alert("<%= LocalizedMessage.getSimpleMessage( "GENERAL_BROWSER_NOT_COMPATIBLE" ) %>"); // TODO
	}
}

		function adjustOpen(ext) {
			select = my_getelementbyid("select_"+ext);
			if( ext == "xml" ) {
				url = "/scheduler/printDummyDynamic.jsp?cFileName="+escape(select.options[select.selectedIndex].value);
			}
			else {
				url = "/attachment/"+escape(select.options[select.selectedIndex].value);
			}
			link = my_getelementbyid("link_"+ext);
			link.href=url;
		}

		
		function adjustedPrint(ext, admindir) {
			select = my_getelementbyid("select_"+ext);
			url = "";
			if( ext == "xml" ) {
				printURL = "/scheduler/printDummyDynamic.jsp?cFileName="+escape(select.options[select.selectedIndex].value);
				url = "/scheduler/printServer.jsp?cPrintURL=" + escape( printURL );
			}
			else if( ext == "jpg" ) {
				printURL = "/scheduler/printStatic.jsp?cFileName="+escape(select.options[select.selectedIndex].value) + "&cPrintType=server";
				url = "/scheduler/printServer.jsp?cPrintURL=" + escape( printURL );
			}
			else if( ext == "pdf" ) {
				url = "/scheduler/printPdf.jsp?cFileName=" + admindir + "/" + escape(select.options[select.selectedIndex].value);
			}
			window.open( url, 'printStatic', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes, width=200, height=50');
			return false;
		}
		
	</script>
	
</HEAD>
<BODY>
<%
  TabToolbox.makeTabs( is, is.tabbean, "scheduler/browseDocuments.jsp", "White");
%>
  <CENTER>
<TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0 WIDTH=100% class=BgShadow><tr><td>
<TABLE CELLPADDING=0 CELLSPACING=0 WIDTH=100%>
<form name="imageForm" method=post action="reportXML.jsp">
<%
	boolean globalIsEmpty=true;
	Set<String> extensions = new HashSet<String>();
	extensions.add("pdf");
	globalIsEmpty &= printSection(is, "pdf", extensions, null);
	extensions.clear();
	extensions.add("doc");
	globalIsEmpty &= printSection(is, "doc", extensions, null);
	extensions.clear();
	extensions.add("jpg");
	extensions.add("jpeg");
	extensions.add("gif");
	globalIsEmpty &= printSection(is, "jpg", extensions, LocalizedMessage.getSimpleMessage( "CASES_BROWSEDOCUMENTS_IMAGE_DOC_SERVER" ) );
	extensions.clear();
	extensions.add("xml");
	globalIsEmpty &= printSection(is, "xml", extensions, null );
	if (globalIsEmpty) {
		%>
		<tr><td><%= LocalizedMessage.getSimpleMessage( "CASES_BROWSEDOCUMENTS_NO_DOCUMENTS" ) %>.</td></tr>
		<% 
	}
%>
			</form>
		</table>
	</td>
</tr>
</table>
</CENTER>
</BODY>
</HTML>