<%@
	page import="
			java.sql.*,
			java.text.Format,
			java.util.*,
			

			imagemed.dcprocessing.OrderImport,
			imagemed.exception.*,
			imagemed.http.IMRequest,
			imagemed.http.tabs.TabBean,
			imagemed.imtables.*,
			imagemed.imsession.*,
			imagemed.jsputil.*,
			imagemed.layout.*,
			imagemed.layout.datasource.*,
			imagemed.layout.datasource.pointer.*,
			imagemed.layout.macro.button.*,
			imagemed.layout.validator.Validator,
			imagemed.lists.*,
			imagemed.scheduler.SchedulerInterface,
			imagemed.tables.*,
			imagemed.types.IMType,
			imagemed.types.date.IMTypeDA_TM,
			imagemed.types.enumeration.*,
			imagemed.types.flag.IMTypeur,
			imagemed.types.string.IMTypePN,
			imagemed.util.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	static String thisPage = "/scheduler/orders.jsp";
	static String indexPage = "/scheduler/index.jsp";
	static String patientsPage = "/scheduler/patients.jsp";
	static String logsPage = "/imadmin/logs.jsp";
	static String referrersPage = "/scheduler/referrers.jsp";

%><%

	IMSession is = new IMSession( request, response, out );

	String parOper = is.getButtonParam( "cOp" );
	String parOperOrig = is.getButtonParam( "cOpOrig" );
	String parBack = request.getParameter( "cBack" );
	if ( !is.regOK() ) {
		return;
	}
	IMRequest reqPar = is.imRequest;
	String parOrder = reqPar.getVal( "c0ZID" );
	String context = reqPar.m_context;
	String parFileName = request.getParameter( "cFileName" );
	String parPrintType = request.getParameter( "cPrintType" );
	String parPrintOnly = request.getParameter( "cPrintOnly" );
	String parFieldName = request.getParameter( "cFieldName" );
	String parLockID = request.getParameter( "cIMLockID" );
	boolean isPreview = "yes".equals( request.getParameter( "cPreview" ) );
	boolean isSeeDeleted = "true".equals( is.imRequest.digUpVal( "cSeeDeleted", "" ) );
	String parLPParams = request.getParameter( PrintButtonMacro.LPPARAMS );
	String[] otherIDs = is.imRequest.getVals( "cOtherIDs" );

	Helper.DEBUG( "SaveAndNext orders.jsp", "Op: " + parOper + " LockID: " + parLockID + " Context: " + context );

	boolean hasAdminRights = is.hasRight( IMTypeur.ADMIN_RIGHT );
	boolean hasSchedulerRights = is.hasRight( IMTypeur.SCHEDULING_RIGHT );
	boolean hasDeleteRights = is.hasRight( IMTypeur.SCHEDULER_DELETE_ORDER_PATIENT_RIGHT );
	//	boolean hasSupportRights = is.hasRight( IMTypeur.SUPPORT_RIGHT );
	boolean hasCreateEditRights = is.hasRight( IMTypeur.SCHEDULER_CREATE_EDIT_ORDER_RIGHT );
	boolean hasCancelRights = is.hasRight( IMTypeur.SCHEDULER_CANCEL_RIGHT );
	boolean hasCheckInOutRights = is.hasRight( IMTypeur.SCHEDULER_CHECK_IN_OUT_RIGHT );
	boolean hasSeeLogsRights = is.hasRight( IMTypeur.SEE_LOG_RIGHT );
	boolean hasCalendarRights = is.hasRight( IMTypeur.SCHEDULER_SCHEDULE_UNSCHEDULE_RIGHT + IMTypeur.SCHEDULER_VIEW_CALENDAR_RIGHT );

	if ( !Table.isExporting( is ) ) {
		is.setNonCacheable();
		if ( parOper == null ) {
			if ( context == null || context.length() == 0 ) {
				context = reqPar.backupContext();
				// we did not have a context, redirect the page now.
				response.sendRedirect( thisPage + "?cContext=" + context );
				return;
			}
			else {
				// just save the context
				reqPar.passAsFile( context );
			}
		}
	}
	if ( !hasSchedulerRights ) {
		throw new IMGeneralException(
				LocalizedMessage.getCompoundMessage( "EXCEPTION_SCHEDULER_ORDERS_NO_RIGHTS", new Format[]{ null }, new Object[]{ is.regID }, true ),
				"scheduler/orders.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_SCHEDULER_ERROR" ), "/scheduler/orders.jsp" );
	}

	DBLayoutDataSource dblds = EntryLayoutFactory.getDefaultDBLDS( is, LayoutPart.SCHORDERLAYOUT );

	FieldManager fm = EntryLayoutFactory.getDefaultFieldManager( is, LayoutPart.SCHORDERLAYOUT );

	String orderTable = IMEnvBase.getEnv( "SCHEDULERORDERTBL" );
	String patientTable = IMEnvBase.getEnv( "SCHEDULERPATIENTTBL" );
	String orderreferrerTable = IMEnvBase.getEnv( "SCHEDULERORDERREFERRERTBL" );

	// --- Init Table without Result ---

	String thisPageMenuTab = thisPage.substring( 1 );
	TableDescriptor tdesc = new TableDescriptor( thisPage, true, true, true, false );
	TableProperties tprop = new TableProperties();

	boolean isNextPrev = false;
	if ( "SaveAndNext".equals( parOper ) ||
			"SaveAndPrev".equals( parOper ) ||
			"ViewNext".equals( parOper ) ||
			"ViewPrev".equals( parOper ) ) {
		isNextPrev = true;
		if ( context == null ) {
			context = SchedulerInterface.getContextFromBack( parBack );
		}
		Helper.DEBUG( "SaveAndNext context: " + context );

		if ( context != null ) {
			is.imRequest.m_context = context;
			is.imRequest.mergeContext( thisPage );
		}
	}

	WorklistTableParams tparams = new WorklistTableParams( is, is.getProfileUser(), is.regRights.indexOf( 'A' ) > -1, is.isRegisteredViewer() );

	tparams.setDefaults( thisPage, is );

	tdesc.setFieldManager( fm );
	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );
	tdesc.setSortDepth( 3 );

	if ( isNextPrev ) {
		tparams.setPageSize( -1 );
	}

	List<Action> act = new ArrayList<Action>();

	act.add( new LinkAction( tdesc, "0ZID", "javascript:redirPage_b(\"orders.jsp?c0ZID=$$0ZID$$&cOp=View\")",
			"<script language=\"JavaScript\">getImage(\'qview\', 18, 20, \' alt=\"" + LocalizedMessage.getSimpleMessage( "VIEW_SCHEDULER_ORDER" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "VIEW_SCHEDULER_ORDER" ) + "\"\');</script>",
			LocalizedMessage.getSimpleMessage( "VIEW_SCHEDULER_ORDER" ) ) );

	//edit button
	if ( hasCreateEditRights ) {
		act.add( new LinkAction( tdesc, "0ZID", "javascript:redirPage_b(\"orders.jsp?c0ZID=$$0ZID$$&cOp=Edit\")",
				"<script language=\"JavaScript\">getImage(\'edit\', 18, 20, \' alt=\"" + LocalizedMessage.getSimpleMessage( "EDIT_SCHEDULER_ORDER" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "EDIT_SCHEDULER_ORDER" ) + "\"\');</script>",
				LocalizedMessage.getSimpleMessage( "EDIT_SCHEDULER_ORDER" ) ) );
	}

	//cancel button
	if ( hasCancelRights ) {
		act.add( new ConditionalLinkAction( tdesc, "0ZID", "javascript:redirPage_b(\"orders.jsp?c0ZID=$$0ZID$$&cOp=Cancel&cContext=" + context + "\")",
				"cancela", "18", "20", LocalizedMessage.getSimpleMessage( "CANCEL_SCHEDULER_ORDER" ), LocalizedMessage.getSimpleMessage( "CANCEL_SCHEDULER_ORDER" ) ) {

			@Override
			public boolean isButtonThere( IMSession _is, Result result ) {
				String stateStr = result.getValue( "0ZST", "" );
				if ( stateStr == null ) {
					return ( false );
				}
				else {
					try {
						int state = Integer.parseInt( stateStr );
						return ( ( state != IMTypeos.INTSTATE_CANCELLED ) &&
						( state < IMTypeos.INTSTATE_UNVIEWED ) );
					}
					catch ( Throwable th ) {
						return ( false );
					}
				}
			}
		} );
	}

	//schedule button
	if ( hasCalendarRights ) {
		act.add( new ConditionalLinkAction( tdesc, "0ZID", "javascript:redirPage_b(\"orders.jsp?c0ZID=$$0ZID$$&cOp=Schedule&cContext=" + context + "\")",
				"schedule", "18", "20", LocalizedMessage.getSimpleMessage( "SCHEDULE_SCHEDULER_ORDER" ), LocalizedMessage.getSimpleMessage( "SCHEDULE_SCHEDULER_ORDER" ) ) {

			@Override
			public boolean isButtonThere( IMSession _is, Result result ) {
				String stateStr = result.getValue( "0ZST", "" );
				if ( stateStr == null ) {
					return ( false );
				}
				else {
					try {
						int state = Integer.parseInt( stateStr );
						return ( state < IMTypeos.INTSTATE_SCHEDULED ); //not scheduled
					}
					catch ( Throwable th ) {
						return ( false );
					}
				}
			}
		} );
	}

	//check in button
	if ( hasCheckInOutRights ) {
		act.add( new ConditionalLinkAction( tdesc, "0ZID", "javascript:redirPage_b(\"orders.jsp?c0ZID=$$0ZID$$&cOp=CheckIn\")",
				"checkin", "18", "20", LocalizedMessage.getSimpleMessage( "CHECKIN_SCHEDULER_ORDER" ), LocalizedMessage.getSimpleMessage( "CHECKIN_SCHEDULER_ORDER" ) ) {

			@Override
			public boolean isButtonThere( IMSession _is, Result result ) {
				String stateStr = result.getValue( "0ZST", "" );
				String checkStateStr = result.getValue( "0ZCS", "" );
				if ( "".equals( stateStr ) || "".equals( checkStateStr ) ) {
					return ( false );
				}
				else {
					return ( IMTypehs.STATE_NONE.equals( checkStateStr ) &&
					( IMTypeos.STATE_SCHEDULED.equals( stateStr ) ||
							IMTypeos.STATE_INPROCESS.equals( stateStr ) ||
							IMTypeos.STATE_UNVIEWED.equals( stateStr ) ||
					IMTypeos.STATE_COMPLETED.equals( stateStr ) ) );
				}
			}
		} );

		//check out button
		act.add( new ConditionalLinkAction( tdesc, "0ZID", "javascript:redirPage_b(\"orders.jsp?c0ZID=$$0ZID$$&cOp=CheckOut\")",
				"checkout", "18", "20", LocalizedMessage.getSimpleMessage( "CHECKOUT_SCHEDULER_ORDER" ), LocalizedMessage.getSimpleMessage( "CHECKOUT_SCHEDULER_ORDER" ) ) {

			@Override
			public boolean isButtonThere( IMSession _is, Result result ) {
				String stateStr = result.getValue( "0ZST", "" );
				String checkStateStr = result.getValue( "0ZCS", "" );
				if ( "".equals( stateStr ) || "".equals( checkStateStr ) ) {
					return ( false );
				}
				else {
					return ( IMTypehs.STATE_CHECKEDIN.equals( checkStateStr ) &&
					( IMTypeos.STATE_CHECKEDIN.equals( stateStr ) ||
							IMTypeos.STATE_INPROCESS.equals( stateStr ) ||
							IMTypeos.STATE_UNVIEWED.equals( stateStr ) ||
					IMTypeos.STATE_COMPLETED.equals( stateStr ) ) );
				}
			}
		} );
	}

	if ( hasDeleteRights ) {
		//delete button
		act.add( new ConditionalLinkAction( tdesc, "0ZID", "javascript:redirPage_b(\"orders.jsp?c0ZID=$$0ZID$$&cOp=Delete\")",
				"delete", "18", "20", LocalizedMessage.getSimpleMessage( "DELETE_SCHEDULER_ORDER" ), LocalizedMessage.getSimpleMessage( "DELETE_SCHEDULER_ORDER" ) ) {

			@Override
			public boolean isButtonThere( IMSession _is, Result result ) {
				String deletedStr = result.getValue( "0ZDL", "no" );
				return ( "no".equals( deletedStr ) );
			}
		} );
	}

	if ( hasSeeLogsRights ) {
		act.add( new LinkAction( tdesc, "0ZID", logsPage + "?qf_0LOI=$$0ZID$$&qf_0LED=(-200 years)()()",
				"<script language=\"JavaScript\">getImage(\'logview\', 18, 20, \' alt=\"" + LocalizedMessage.getSimpleMessage( "SCHEDULER_ORDERS_VIEW_LOGS" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "SCHEDULER_ORDERS_VIEW_LOGS" ) + "\"\');</script>",
				LocalizedMessage.getSimpleMessage( "SCHEDULER_ORDERS_VIEW_LOGS" ) ) );
	}

	/*	
		//teszt PACS in process
		act.add( new LinkAction(tdesc, "0ZID", "javascript:redirPage_b(\"orders.jsp?c0ZID=$$0ZID$$&cOp=TestInProcess\")", 
	  	"<script language=\"JavaScript\">getImage(\'delete\', 18, 20, \' alt=\"Delete Order\"\');</script>", 
		"Test PACS InProcess") );

		//teszt PACS completed
		act.add( new LinkAction(tdesc, "0ZID", "javascript:redirPage_b(\"orders.jsp?c0ZID=$$0ZID$$&cOp=TestCompleted\")", 
	  	"<script language=\"JavaScript\">getImage(\'delete\', 18, 20, \' alt=\"Delete Order\"\');</script>", 
		"Test PACS Completed") );
	*/

	Column col = new Column( new SimpleHeader( "&nbsp;" ), new ActionCell( "0ZID", new Action[]{ new MultiAction( tprop, act.toArray( new Action[ 0 ] ) ) } ), "0ZID" );
	tdesc.addExtraColumn( "_FIRST", col );

	List<TopCell> topCell = new ArrayList<TopCell>();

	TitleTopCell title = new TitleTopCell( tprop, LocalizedMessage.getSimpleMessage( "tabOrders" ) );
	title.clearWidth();

	topCell.add( title );

	topCell.add( new ListsTopCell( ListDescriptor.LIST_SCHEDULERORDERSFILTER, tdesc, is.getProfileUser(), true ) );

	if ( hasCreateEditRights ) {
		topCell.add( new SimpleTopCell( tprop,
				JSHelper.getJsButtonSLink( is, "javascript:redirPage_b('orders.jsp?cOp=New')", "newButton", 0, 0, LocalizedMessage.getSimpleMessage( "ALT_TEXT_ADD_ORDER" ) ) ) );
		topCell.add( new SeparatorTopCell( tprop, 4 ) );
	}

	topCell.add( new FieldsTopCell( tdesc, null, true ) );
	topCell.add( new FiltersTopCell( tdesc, null, false, new String[ 0 ], true ) );
	topCell.add( new SortsTopCell( tdesc, null, false, true ) );

	topCell.add( new SeparatorTopCell( tprop, 4 ) );
	topCell.add( new OrderScheduleModeTopCell( tdesc ) );

	topCell.add( new SeparatorTopCell( tprop, 4 ) );
	topCell.add( new PriorityFirstTopCell( tdesc ) );

	if ( hasCalendarRights ) {
		topCell.add( new SeparatorTopCell( tprop, 4 ) );
		topCell.add( new SimpleTopCell( tprop,
				JSHelper.getJsButtonSLink( is, "index.jsp?cContext=" + context, "schedule", 0, 0, LocalizedMessage.getSimpleMessage( "ALT_TEXT_SCHEDULE" ) ) ) );
	}

	if ( hasAdminRights ) {
		topCell.add( new SeparatorTopCell( tprop, 4 ) );
		topCell.add( new SimpleTopCell( tprop,
				JSHelper.getJsButtonSLink( is, "javascript:redirPage_b('orders.jsp?cOp=AutoValidator')", "validate", 0, 0, LocalizedMessage.getSimpleMessage( "ALT_TEXT_REVALIDATE_ORDERS" ) ) ) );
		topCell.add( new SeparatorTopCell( tprop, 4 ) );
		topCell.add( new SeeDeletedTopCell( tdesc ) );
	}

	topCell.add( new PageTopCell( tprop, tparams ) );
	tdesc.setTopCells( topCell );

	// --- Init Table with Result ---
	if ( Table.isExporting( is ) ) {
		tparams.setPageSize( 0 );
	}
	DBLDSWrapperNatSqlResult result = new DBLDSWrapperNatSqlResult( tdesc, dblds, !isSeeDeleted );
	result.setRequiredFields( new String[]{ "0ZST", "0ZCS", "0ZDL" } );
	//put here the fields that are used in conditional buttons

	//set ScheduleMode - default is Scheduled
	String parSchMode = is.imRequest.digUpVal( "cOrderScheduleMode", OrderScheduleModeTopCell.SCH_DEFAULT );
	String addToWhere = "";
	if ( OrderScheduleModeTopCell.SCH_SCHEDULED.equals( parSchMode ) ) {
		addToWhere = SchedulerInterface.m_scheduledWhereClause;
	}
	else if ( OrderScheduleModeTopCell.SCH_UNSCHEDULED.equals( parSchMode ) ) {
		addToWhere = SchedulerInterface.m_unscheduledWhereClause;
	}
	//don't show Blocks
	addToWhere += SchedulerInterface.m_notBlockWhereClause;
	//don't show Deleted - result constuctorban
	//	addToWhere += " AND " + SchedulerInterface.getNoDeletedWhereClause( orderTable );


	result.addToWhereClause( new QueryPart( addToWhere ) );

	tdesc.setResult( result );
	Table table = new Table( tdesc );

	if ( table.handleExport( is ) ) {
		return;
	}

%><%-- --- HTML --- --%><HTML>
<HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "tabOrders" ) %></TITLE>
<%-- <META http-equiv="Refresh" content="10"> --%>
 <SCRIPT Language="JavaScript">
 	var pageContext="<%=context%>";
 </script>
<%
	if ( !"Print".equals( parOper ) ) {
		TabToolbox.writeIMpopup( is.out );
	}
	else {
		//for Printing Print/Cancel buttons
		TabBean.writeStyleOnly( is );
		Table.printCommonScript( is );
	}
	table.printScript( tparams, is );
	JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
%>
  <SCRIPT language="JavaScript">
		var needUnlock = 1; // in default unlock when leaving page

		function doPopupSubmit(frm, mod, ptype, filename, preview, lpparams) {
			id = window.open("","imw_printfriendly","resizable=yes,scrollbars,toolbar=yes,menubar=yes");
			origtarget = frm.target;
			frm.target = "imw_printfriendly";
			
			while( frm.cPrintType.value != ptype ) {
				frm.cPrintType.value = ptype;
			}

			while( frm.cFileName.value != filename ) {
				frm.cFileName.value = filename;
			}
			
			while( frm.cPreview.value != preview ) {
				frm.cPreview.value = preview;
			}

			if (lpparams) {
				var input = document.createElement("input");
				input.setAttribute("type","hidden");
				input.setAttribute("value",lpparams);
				input.setAttribute("name","<%=PrintButtonMacro.LPPARAMS%>");
				frm.appendChild(input);
			}
			
			doSubmit(frm, mod);
			frm.target = origtarget;
		}


		function doSubmitWithFieldName(frm, mod, fname) {
			while (frm.cFieldName.value != fname) {
				frm.cFieldName.value=fname;
			}
			doSubmit(frm, mod);
		}


		function doSubmit(frm, mod) {
			needUnlock = 0;  // in case of save should not be unlocked
			while (frm.cOp.value != mod) {
				frm.cOp.value=mod;
			}
			frm.submit();
		}

  </script>
</head>
<%
	String onLoad = "";
	if ( "Print".equals( parOper ) &&
			"client".equals( parPrintType ) &&
			!isPreview ) {
		onLoad = " onLoad='javascript:window.print()'";
		Properties logFields = new Properties();
		logFields.setProperty( "0LAC", "Print" );
		SchedulerInterface.makeLogFieldsFromOrder( is, parOrder, logFields );
		SchedulerInterface.logIntoTable( is, logFields );
	}

	//locking
	String onUnload = "";
	boolean isEdit = "New".equals( parOper ) || "Edit".equals( parOper ) || "EditClone".equals( parOper ) || "CheckIn2".equals( parOper ) || "CheckOut".equals( parOper ) || "Cancel".equals( parOper ) || ( parOper != null && parOper.startsWith( "Record" ) ) || "Refresh".equals( parOper )
			|| "ProcedureChanged".equals( parOper ) || "NewCorrection".equals( parOper ) || "MultiCheckIn".equals( parOper );
	boolean isSave = parOper != null && parOper.startsWith( "Save" );
	DBLDSEntry saveEntry = null;
	boolean bLocked = false;
	Properties prpLock = new Properties();

	String lockOrderID = parOrder;
	if ( isEdit && !parOper.startsWith( "New" ) ) {
		onUnload = " onUnload='return unlockOrder()'";
		LDSEntry entry = null;
		String entryName = request.getParameter( "cEntryName" );
		String tmpEntryName = request.getParameter( "cTmpEntryName" );
		if ( entryName != null || tmpEntryName != null ) {
			if ( tmpEntryName != null ) {
				entry = DBLDSEntry.readTmpFile( is, tmpEntryName, dblds, true );
			}
			else {
				entry = DBLDSEntry.readFile( is, entryName, dblds, true );
			}
			dblds.setEntry( entry );
			entry.initFromRequest( is.imRequest );
			lockOrderID = entry.getRootRecord().m_rowID.get( 0 );
		}

		IMLock.lockDBItem( is, orderTable, lockOrderID, "IsLocked", prpLock );
		bLocked = prpLock.getProperty( "IMLockID" ) != null && "OK".equals( prpLock.getProperty( "IMLock" ) );
		if ( !bLocked ) {
			//edit and similar - first time (no entry, just c0ZID)
			if ( parOrder != null && !"".equals( parOrder ) && !"null".equals( parOrder ) ) {
				IMLock.lockDBItem( is, orderTable, lockOrderID, "Lock", prpLock );
				parLockID = prpLock.getProperty( "IMLockID" );
			}
		}
		else {
			parLockID = prpLock.getProperty( "IMLockID" );
			//if I'm blocked, I can not remove the block, it belongs to someone else!
			//Unless break lock is specifically pressed
%>			
			<SCRIPT language="JavaScript">
			  needUnlock = 0;
			</SCRIPT>
<%
		}
	}
	else if ( isSave ) {
		onUnload = " onUnload='return unlockOrder()'";
		saveEntry = DBLDSEntry.readFile( is, request.getParameter( "cEntryName" ), dblds );
		dblds.setEntry( saveEntry );
		saveEntry.initFromRequest( is.imRequest );
		lockOrderID = saveEntry.getRootRecord().m_rowID.get( 0 );
	}
%>
<SCRIPT language="JavaScript">
	function unlockOrder() {
		if (needUnlock) {
			jsPopup('unlockitem.jsp?cTable=<%=orderTable%>&cID=<%=lockOrderID%>&cIMLockID=<%=parLockID%>', 'unlockwindow', true );
			needUnlock = false;
		}
	}
</SCRIPT>

<BODY<%=onLoad%> <%=onUnload%> >
<%
	if ( !"Print".equals( parOper ) ) {
		TabToolbox.makeTabs( is, is.tabbean, thisPageMenuTab, "White" );
	}

	if ( bLocked ) {
		String lockerName = prpLock.getProperty( "IMLockOwner" );
		String lockAge = prpLock.getProperty( "IMLockAge" );
		lockerName = ( null == lockerName ) ? LocalizedMessage.getSimpleMessage( "GENERIC_ANOTHER_USER" ) : IMTypePN.displayOrdinaryText( lockerName );

		MessageBox box = new MessageBox( LocalizedMessage.getSimpleMessage( "GENERIC_LOCKED" ), "60%" );
		String message = "<H2><BR>" + LocalizedMessage.getCompoundMessage( "ORDER_LOCK_LOCKED_BY", new Format[]{ null, null }, new Object[]{ lockerName, ReportToolbox.getLockAgeMessage( lockAge ) }, true );
		if ( is.hasRight( IMTypeur.BREAK_LOCK_RIGHT ) ) {
			message += LocalizedMessage.getSimpleMessage( "LOCK_LOCKED_IS_BREAK" );
		}
		message += "<BR><BR></H2>";

		box.setMessage( message );

		if ( is.hasRight( IMTypeur.BREAK_LOCK_RIGHT ) ) {
			box.addButton( new Button( "javascript:breakLock();", "BUTTON_BREAK", "BUTTON_BREAK_TITLE" ) );
		}
		box.addButton( new Button( parBack, "BUTTON_CANCEL", "BUTTON_CANCEL" ) );
%>
		<script language="JavaScript">
			function breakLock() {
				jsPopup('unlockitem.jsp?cTable=<%=orderTable%>&cID=<%=parOrder%>&cIMLockID=<%=parLockID%>', 'unlockwindow', true, true );
			}
		</script>
	
	  <CENTER><FORM action="<%= thisPage %>" method=get name="breakForm">
<%
		box.print( is.out );
		return;
	} // locked


	// --- Oper ---
	if ( "TestInProcess".equals( parOper ) ) {
		Properties fields = new Properties();
		fields.setProperty( "0ZST", IMTypeos.STATE_INPROCESS );
		fields.setProperty( "0ZYT", "20080101_120000" );
		fields.setProperty( "0ZRT", "20080202_123456" );
		fields.setProperty( "0ZAT", "20080303_723456" );

		SchedulerInterface.orderChangeState( parOrder, fields );

		if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
			document.location="<%=parBack%>";
</script><%
			return;
		}
	}
	else if ( "TestCompleted".equals( parOper ) ) {
		Properties fields = new Properties();
		fields.setProperty( "0ZST", IMTypeos.STATE_COMPLETED );

		SchedulerInterface.orderChangeState( parOrder, fields );

		if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
			document.location="<%=parBack%>";
</script><%
			return;
		}
	}
	else if ( "SeeValidator".equals( parOper ) ) {
		String parLayout = reqPar.getVal( "cLayout" );
		DBLDSEntry entry = new DBLDSEntry( dblds );
		dblds.setEntry( entry );
		entry.initFromExisting( parOrder );
		is.imRequest.setProperty( "cDisplayType", "FromList" );
		String editURL = null;

		if ( LayoutPart.SCHORDERCHECKINLAYOUT.equals( parLayout ) ) {
			editURL = thisPage + "?cOp=CheckIn2";
		}
		else if ( LayoutPart.SCHORDERCHECKOUTLAYOUT.equals( parLayout ) ) {
			editURL = thisPage + "?cOp=CheckOut";
		}
		else if ( LayoutPart.SCHORDERCANCELLAYOUT.equals( parLayout ) ) {
			editURL = thisPage + "?cOp=Cancel";
		}

		if ( Validator.doValidation( is, parLayout, dblds, editURL, null ) ) {
			if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
				document.location="<%=parBack%>";
</script><%
				return;
			}
		}
		else {
			return;
		}
	}
	else if ( "AutoValidator".equals( parOper ) ) {
		String layoutType = LayoutPart.SCHORDERLAYOUT;
		is.imRequest.setProperty( "cDisplayType", "Nothing" );
		//in case of warnings, change the flag only
		is.imRequest.setProperty( "cIgnoreWarns", "true" );
		DBLDSEntry entry = new DBLDSEntry( dblds );
		dblds.setEntry( entry );
		//vegig kene menni az osszes ordereken 
		Statement st = IMEnv.getDB().createStatement();
		String rowIDName = IMBaseFieldManager.staticGetDbName( "0ZID" );
		String query = "select " + rowIDName + " from " + orderTable;
		query += " where " + SchedulerInterface.m_notBlockWhereClause.substring( 4 );

		Helper.DEBUG( "AutoValidator", "query: " + query );

		ResultSet rs = st.executeQuery( query );
		while ( rs.next() ) {
			Helper.DEBUG( "AutoValidator", "ID: " + rs.getString( rowIDName ) );
			entry.initFromExisting( rs.getString( rowIDName ) );
			Validator.doValidation( is, layoutType, dblds, null, null );
			SchedulerInterface.setLastModified( entry, "0ZMT" );
			entry.commit(); //saving warning flag 
		}
		if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
			document.location="<%=parBack%>";
</script><%
			return;
		}
	}
	else if ( "Skip".equals( parOper ) ) {
		if ( otherIDs != null && otherIDs.length > 0 ) {
			String redir = thisPage + "?cOp=MultiCheckIn&cBack=" + Helper.URLEncodeUTF8( parBack );
			boolean first = true;
			for ( int i = 0; i < otherIDs.length; i++ ) {
				if ( first ) {
					first = false;
					redir += "&c0ZID=" + otherIDs[ i ];
				}
				else {
					redir += "&cOtherIDs=" + otherIDs[ i ];
				}
			}
%><script language="JavaScript">
				document.location="<%=redir%>";
</script><%
			return;
		}
		else {
			if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
					document.location="<%=parBack%>";
</script><%
				return;
			}
		}
	}

	else if ( isEdit || "View".equals( parOper ) || "Print".equals( parOper ) ) {
		if ( "View".equals( parOper ) || "New".equals( parOper ) || "Edit".equals( parOper ) || "CheckIn2".equals( parOper ) || "CheckOut".equals( parOper ) || "Cancel".equals( parOper ) || "NewCorrection".equals( parOper ) || "MultiCheckIn".equals( parOper ) ) {
			parOperOrig = parOper;
		}
		else if ( "EditClone".equals( parOper ) ) {
			parOperOrig = "Edit";
			//no need for cloning again!
		}

		if ( !parOper.equals( "Print" ) ) {
			String entity = "SCHEDULER_ORDER";
			if ( "View".equals( parOper ) || "Edit".equals( parOper ) ) {
				if ( parOrder != null && !"".equals( parOrder ) ) {
					DBLDSEntry tmpEntry = new DBLDSEntry( dblds );
					tmpEntry.initFromExisting( parOrder );

					boolean isBlock = "yes".equals( tmpEntry.getRootRecord().getCurrentValue( "0ZBL", "no" ) );
					if ( isBlock ) {
						entity = "Block";
					}
				}
			}
			SchedulerInterface.putLabel( is, entity, parOperOrig );
		}

		LDSEntry entry = null;
		String entryName = request.getParameter( "cEntryName" );
		String tmpEntryName = request.getParameter( "cTmpEntryName" );
		if ( entryName != null || tmpEntryName != null ) {
			//record operation
			//print here
			if ( tmpEntryName != null ) {
				entry = DBLDSEntry.readTmpFile( is, tmpEntryName, dblds );
			}
			else {
				boolean keepFile = "Print".equals( parOper );
				entry = DBLDSEntry.readFile( is, entryName, dblds, keepFile );
			}
			dblds.setEntry( entry );
			entry.initFromRequest( is.imRequest );

			if ( RecordButtonMacro.doRecordOperation( dblds, is ) || "Refresh".equals( parOper ) || "ProcedureChanged".equals( parOper ) ) {
				if ( "ProcedureChanged".equals( parOper ) ) {
					LDSRecord rootRec = entry.getRootRecord();
					String procID = rootRec.getCurrentValue( "0ZRI", "" );
					String deviceID = "";
					List<LDSRecord> devprocRecList = rootRec.getChildList( IMEnvBase.getEnv( "SCHEDULERDEVPROCTBL" ) );
					if ( devprocRecList != null && devprocRecList.size() >= 1 ) {
						for ( int i = 0; i < devprocRecList.size(); i++ ) {
							LDSRecord devprocRec = devprocRecList.get( i );
							deviceID = devprocRec.getCurrentValue( "0EDI", "" );
						}

						if ( !"".equals( procID ) && !"".equals( deviceID ) ) {
							Statement st = IMEnv.getDB().createStatement();

							String query = "select " + IMBaseFieldManager.staticGetDbName( "0EID" ) + " from ";
							query += IMEnvBase.getEnv( "SCHEDULERDEVPROCTBL" ) + " where ";
							query += IMBaseFieldManager.staticGetDbName( "0EDI" ) + " = '" + deviceID;
							query += "' AND " + IMBaseFieldManager.staticGetDbName( "0EPI" ) + " = '" + procID + "'";
							ResultSet rs = st.executeQuery( query );
							while ( rs.next() ) {
								String newDevProcID = rs.getString( 1 );
								if ( newDevProcID != null ) {
									rootRec.setValue( "0ZDP", newDevProcID );
								}
							}
						}
					}
				}
				if ( parOperOrig != null ) {
					parOper = parOperOrig;
				}
				else {
					parOper = "Edit";
				}
			}
		}
		else {
			entry = new DBLDSEntry( dblds );
			dblds.setEntry( entry );
			if ( parOper.startsWith( "New" ) ) {
				// create a default empty order
				LDSRecord rootRec = entry.addRecord( dblds.getTable(), null ); // root record

				//set status to Ordered
				rootRec.setValue( "0ZST", IMTypeos.STATE_ORDERED );

				// add one referrer
				DBLDSRecord orderreferrerRec = (DBLDSRecord) entry.addRecord( orderreferrerTable, rootRec );
				// set fields when Correction sets them
				SchedulerInterface.setFieldsFromRequest( orderreferrerRec, reqPar, orderreferrerTable );
			}
			else {
				entry.initFromExisting( parOrder );
				if ( "EditClone".equals( parOper ) ) {
					entry.resetIDs();
					//EditClone klonozas itt
					//set Procedure ID to empty (Jim)
					LDSRecord rootRec = entry.getRootRecord();
					rootRec.setValue( "0ZRI", "" );
					//set Order State to Ordered
					rootRec.setValue( "0ZST", IMTypeos.STATE_ORDERED );
					//set check-in state to not checked in
					rootRec.setValue( "0ZCS", IMTypehs.STATE_NONE );
					//delete scheduled start time, end time, devprocid
					rootRec.setValue( "0ZSS", "" );
					rootRec.setValue( "0ZSE", "" );
					rootRec.setValue( "0ZDP", "" );
				}
			}
			// set patientID if needed
			DBLDSRecord rootRec = (DBLDSRecord) entry.getRootRecord();
			String patientID = request.getParameter( "c0ZPI" );
			if ( patientID != null ) {
				rootRec.setValue( "0ZPI", patientID );

				//needed for prevalidator -copying from patient
				rootRec.collectChildrenFromDB( patientTable );

				//emulating refresh for prevalidator
				is.imRequest.setProperty( "refreshType", Validator.REFRESHTYPE_FIELDCHANGE );
				is.imRequest.setProperty( "refreshingField", new FieldInstancePointer( orderTable, rootRec.m_rowID, "0ZPI" ).composeFormInputName() );
			}
			// set fields when Correction sets them
			SchedulerInterface.setFieldsFromRequest( rootRec, reqPar, IMEnvBase.getEnv( "SCHEDULERORDERTBL" ) );
		}

		if ( "CheckIn2".equals( parOper ) || "MultiCheckIn".equals( parOper ) ) {
			//set State to CHECKED IN
			LDSRecord rootRec = entry.getRootRecord();
			int actState = Integer.parseInt( rootRec.getCurrentValue( "0ZST", IMTypeos.STATE_ORDERED ) );
			if ( actState <= IMTypeos.INTSTATE_SCHEDULED ) {
				rootRec.setValue( "0ZST", IMTypeos.STATE_CHECKEDIN );
			}

			if ( !IMTypehs.STATE_CHECKEDIN.equals( rootRec.getCurrentValue( "0ZCS", "" ) ) ) {
				rootRec.setValue( "0ZCS", IMTypehs.STATE_CHECKEDIN );
				//emulating refresh for prevalidator
				is.imRequest.setProperty( "refreshType", Validator.REFRESHTYPE_FIELDCHANGE );
				is.imRequest.setProperty( "refreshingField", new FieldInstancePointer( orderTable, rootRec.m_rowID, "0ZCS" ).composeFormInputName() );
			}
		}
		else if ( "CheckOut".equals( parOper ) ) {
			//set State to CHECKED OUT
			LDSRecord rootRec = entry.getRootRecord();
			rootRec.setValue( "0ZCS", IMTypehs.STATE_CHECKEDOUT );
			int actState = Integer.parseInt( rootRec.getCurrentValue( "0ZST", IMTypeos.STATE_ORDERED ) );
			if ( actState <= IMTypeos.INTSTATE_UNVIEWED ) {
				rootRec.setValue( "0ZST", IMTypeos.STATE_CHECKEDOUT );
			}
		}
		else if ( "Cancel".equals( parOper ) ) {
			//set State to CANCELLED
			LDSRecord rootRec = entry.getRootRecord();
			rootRec.setValue( "0ZCS", IMTypehs.STATE_NONE );
			rootRec.setValue( "0ZST", IMTypeos.STATE_CANCELLED );
		}

		dblds.setRepeatPointer( dblds.getTable(), 0 );
		if ( isEdit ) {
%>
    <FORM action="<%=thisPage%>" method=post name="saveForm" id="saveForm">
			<INPUT type="hidden" name="cBack" value="<%=request.getParameter("cBack")%>">
			<input type=hidden name=cOp value="Save">
			<input type=hidden name=cOpOrig value="<%=parOperOrig%>">
			<input type=hidden name=cPrintType value="uninited">
			<input type=hidden name=cFileName value="uninited">
			<input type=hidden name=cPreview value="uninited">
			<input type=hidden name=cFieldName value="uninited">
			<input type=hidden name=cIMLockID value="<%=parLockID%>">
<%
			if ( "New".equals( parOper ) || "EditClone".equals( parOper ) ||
					"Yes".equals( request.getParameter( "isNew" ) ) ) {
%>
				<input type=hidden name=isNew value="Yes">
<%
			}
			if ( "NewCorrection".equals( parOper ) ||
					"NewCorrection".equals( parOperOrig ) ) {
%>
				<input type=hidden name=cContext value=<%=context%>>
<%
			}
			if ( otherIDs != null ) {
				for ( int i = 0; i < otherIDs.length; i++ ) {
%>
					<input type=hidden name=cOtherIDs value=<%=otherIDs[ i ]%>>
<%
				}
			}
		}
		else if ( "View".equals( parOper ) ) {
%>
	    <FORM action="<%=thisPage%>" method=post name="saveForm" id="saveForm">
				<INPUT type="hidden" name="cBack" value="<%=request.getParameter("cBack")%>">
				<input type=hidden name=cOp value="View">
				<input type=hidden name=c0ZID value="<%=parOrder%>">
			</FORM>
<%
		}

		LayoutRoot root;
		boolean isViewNew = "View".equals( parOper ) || "Print".equals( parOper );
	  	boolean wasNew = parOperOrig != null && parOperOrig.startsWith( "New" );
	  	OperatingMode mode = isViewNew ? LayoutPart.VIEWING : ( wasNew ?  LayoutPart.CREATE : LayoutPart.EDITING );
		String layoutType = LayoutPart.SCHORDERLAYOUT;
		if ( "CheckIn2".equals( parOper ) || "MultiCheckIn".equals( parOper ) ) {
			layoutType = LayoutPart.SCHORDERCHECKINLAYOUT;
		}
		else if ( "CheckOut".equals( parOper ) ) {
			layoutType = LayoutPart.SCHORDERCHECKOUTLAYOUT;
		}
		else if ( "Cancel".equals( parOper ) ) {
			layoutType = LayoutPart.SCHORDERCANCELLAYOUT;
		}

		if ( "Print".equals( parOper ) ) {
			layoutType = LayoutPart.SCHPRINTLAYOUT;
			if ( parFileName == null ) {
				throw new IMException( "cFileName is null in Print operation" );
			}
			root = imagemed.layout.cache.LayoutCache.getLayout( is, layoutType, parFileName );
			mode = LayoutPart.PRINTFRIENDLY;
		}
		else {
			root = imagemed.layout.cache.LayoutCache.getSystemLayout( is, layoutType );
		}
		String html = root.getHtml( "  " + ( isViewNew ? "" : "  " ), mode, dblds );
		out.println( html );
		if ( isEdit ) {
			String savedName = LDSEntry.writeFile( is, entry );
%>
			<input type=hidden name=cEntryName id=cEntryName value="<%=savedName%>">
</FORM>
<%
			root.writeJSCommands( is );
		}
		else if ( "Print".equals( parOper ) ) {
			if ( isPreview ) {
				entryName = LDSEntry.writeFile( is, entry );
				if ( "client".equals( parPrintType ) ) {
					out.println( "<BR><BR><A HREF=\"" + thisPage + "?cEntryName=" + entryName + "&cOp=Print&c0ZID=" + entry.getRootRecord().m_rowID.get( 0 ) + "&cFileName=" + parFileName + "&cPrintType=client\">" );
					//no preview
				}
				else {
					String printURL = thisPage + "?cOp=Print&c0ZID=" + entry.getRootRecord().m_rowID.get( 0 ) + "&cFileName=" + parFileName + "&cPrintType=server&cPrintOnly=yes";
					String URL = "/scheduler/printServer.jsp?cPrintURL=" + Helper.URLEncodeUTF8( printURL ) + "&cLayoutType=" + LayoutPart.SCHORDERLAYOUT + "&cEntryName=" + entryName;
					if ( parLPParams != null ) {
						URL += "&" + PrintButtonMacro.LPPARAMS + "=" + Helper.URLEncodeUTF8( parLPParams );
					}
					out.println( "<BR><BR><A HREF=\"" + URL + "\">" );
				}
				out.println( JSHelper.getJsButton( is, "print", LocalizedMessage.getSimpleMessage( "ALT_TEXT_PRINT" ) ) );
				out.println( "</A>" );

				out.println( "&nbsp;<A HREF='#' onClick=\"window.close(); return false;\"> " );
				//no preview
				out.println( JSHelper.getJsButton( is, "cancelButton", LocalizedMessage.getSimpleMessage( "BUTTON_CANCEL_TITLE" ) ) );
				out.println( "</A>" );
			}
			else {
				if ( "server".equals( parPrintType ) &&
						!"yes".equals( parPrintOnly ) ) {
					//redirect to printServer.jsp 
					entryName = LDSEntry.writeFile( is, entry );
					String printURL = thisPage + "?cOp=Print&c0ZID=" + entry.getRootRecord().m_rowID.get( 0 ) + "&cFileName=" + parFileName + "&cPrintType=server&cPrintOnly=yes";
					String redir = "/scheduler/printServer.jsp?cPrintURL=" + Helper.URLEncodeUTF8( printURL ) + "&cLayoutType=" + LayoutPart.SCHORDERLAYOUT + "&cEntryName=" + entryName;
					if ( parLPParams != null ) {
						redir += "&" + PrintButtonMacro.LPPARAMS + "=" + Helper.URLEncodeUTF8( parLPParams );
					}
%><script language="JavaScript">
	document.location="<%=redir%>";
</script><%
				}
			}
		}
%>
</body>
</html>
<%
		return;
	}
	else if ( "Delete".equals( parOper ) ) {
%>
  	<FORM name="operForm" method="POST" action="<%=thisPage%>">
  		<CENTER>
	  	<H2><P>&nbsp;
			<P><%=LocalizedMessage.getSimpleMessage( "SCHEDULER_ORDERS_DELETE_MSG" )%>
			<P>
			<input type=hidden name="c0ZID" value="<%=parOrder%>">
			<input type=hidden name="cBack" value="<%=parBack%>">
			<%=JSHelper.getJsInputLocalizedButton( is, "BUTTON_DELETE", "cOp", "DeleteSure")%>
			&nbsp; &nbsp; &nbsp; &nbsp;
			<a href="<%=parBack%>"><%=JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false )%></a>
			</H2>
  		</CENTER>
		</FORM>
</body>
</html>
<%
		return;

	}
	else if ( "DeleteSure".equals( parOper ) ) {
		if ( !"true".equals( is.imRequest.digUpVal( "cIgnoreWarns", "" ) ) ) {
			DBLDSEntry entry = new DBLDSEntry( dblds );
			dblds.setEntry( entry );
			entry.initFromExisting( parOrder );

			if ( !Validator.doDeleteValidation( is, LayoutPart.SCHORDERLAYOUT, dblds, null ) ) {
				// form with errors or warnings displayed...
				return;
			}
		}


		Properties logFields = new Properties();
		logFields.setProperty( "0LAC", "Delete" );
		SchedulerInterface.makeLogFieldsFromOrder( is, parOrder, logFields );
		SchedulerInterface.logIntoTable( is, logFields );

		SchedulerInterface.sendOrderMessageToPacs( OrderImport.CANCEL_ORDER, parOrder, is );

		SchedulerInterface.deleteRecord( orderTable, "0ZID", parOrder );
		AttachmentManager.setAttachmentCounts( parOrder, false, 0, 0 );
		//		dblds.deleteRecord(orderTable, parOrder);

		if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
			document.location="<%=parBack%>";
</script><%
//			response.sendRedirect( parBack );
			return;
		}
	}
	else if ( "CheckIn".equals( parOper ) ) {
		String redir = patientsPage;
		//modify to this patient ID only	
		//and redir to patients.jsp
		DBLayoutDataSource dbtemp = new DBLayoutDataSource( is, null, orderTable, "0ZID", parOrder );
		String patientID = dbtemp.getValue( "0ZPI" );
		redir += "?cOp=CheckIn&cBack=" + Helper.URLEncodeUTF8( parBack );
		redir += "&c0ZID=" + parOrder;
		if ( patientID != null ) {
			redir += "&c0PAI=" + patientID;
		}
%><script language="JavaScript">
		document.location="<%=redir%>";
</script><%
//		response.sendRedirect( redir );
		return;
	}
	else if ( "Schedule".equals( parOper ) ) {
		String redir = indexPage;
		//modify context to this patient ID only	
		//and redir to calendar
		DBLayoutDataSource dbtemp = new DBLayoutDataSource( is, null, orderTable, "0ZID", parOrder );
		dbtemp.addJoinTable( orderTable, patientTable, "0ZPI" );
		String PatientID = dbtemp.getValue( new FieldPointer( patientTable, "0UPI" ) );
		if ( PatientID != null ) {
			IMProperties.setValueInFile( reqPar.getContextFileName( context ), "qf_0UPI", PatientID );
		}
		redir += "?cContext=" + context;
%><script language="JavaScript">
		document.location="<%=redir%>";
</script><%
//		response.sendRedirect( redir );
		return;
	}
	else if ( "NewPatient".equals( parOper ) ||
			"NewReferrer".equals( parOper ) ) {
		DBLDSEntry entry = DBLDSEntry.readFile( is, request.getParameter( "cEntryName" ), dblds );
		dblds.setEntry( entry );
		entry.initFromRequest( is.imRequest );

		String entryName = DBLDSEntry.writeFile( is, entry );

		String redir;
		if ( "NewPatient".equals( parOper ) ) {
			redir = patientsPage;
		}
		else {
			redir = referrersPage;
		}
		String back = thisPage + "?cOp=Edit&cEntryName=" + entryName + "&cBack=" + Helper.URLEncodeUTF8( parBack );
		if ( "Yes".equals( request.getParameter( "isNew" ) ) ) {
			back += "&isNew=Yes";
		}
		if ( parLockID != null ) {
			back += "&cIMLockID=" + Helper.URLEncodeUTF8( parLockID );
		}
		redir += "?cOp=NewBackToOrder&cBack=" + Helper.URLEncodeUTF8( back )
				+ "&cOrderEntryName=" + entryName + "&cOrderFieldName=" + Helper.URLEncodeUTF8( parFieldName );
%><script language="JavaScript">
		document.location="<%=redir%>";
</script><%
//		response.sendRedirect( redir );
		return;
	}
	else if ( "ViewNext".equals( parOper ) || "ViewPrev".equals( parOper ) ) {
		Helper.DEBUG( "SaveAndNext find row for: " + parOrder );
		String[] prevNext = result.findRow( parOrder );

		String redir = thisPage;
		if ( "ViewNext".equals( parOper ) && prevNext != null && prevNext.length >= 2 && prevNext[ 1 ] != null ) {
			Helper.DEBUG( "SaveAndNext Next found: " + prevNext[ 1 ] );
			redir += "?cOp=View&c0ZID=" + prevNext[ 1 ];
			if ( parBack != null && parBack.length() > 0 ) {
				redir += "&cBack=" + Helper.URLEncodeUTF8( parBack );
			}
		}
		else if ( "ViewPrev".equals( parOper ) && prevNext != null && prevNext[ 0 ] != null ) {
			redir += "?cOp=View&c0ZID=" + prevNext[ 0 ];
			if ( parBack != null && parBack.length() > 0 ) {
				redir += "&cBack=" + Helper.URLEncodeUTF8( parBack );
			}
		}
		else {
			if ( parBack != null && parBack.length() > 0 ) {
				redir = parBack;
			}
		}
%><script language="JavaScript">
		document.location="<%=redir%>";
</script><%
		return;
	}
	else if ( isSave ) {
		//validation
		String editURL = null;
		String layout = LayoutPart.SCHORDERLAYOUT;

		if ( "NewCorrection".equals( parOperOrig ) ) {
			String params = "&cContext=" + context;
			editURL = thisPage + "?cOp=NewCorrection" + params;
			String saveURL = thisPage + "?cOp=Save" + params;
			//cBack will be added by validator
			if ( !Validator.doValidation( is, layout, dblds, editURL, saveURL ) ) {
				// form with errors or warnings displayed...
				return;
			}
		}
		else {
			if ( "CheckIn2".equals( parOperOrig ) ) {
				editURL = thisPage + "?cOp=CheckIn2";
				layout = LayoutPart.SCHORDERCHECKINLAYOUT;
			}
			else if ( "MultiCheckIn".equals( parOperOrig ) ) {
				editURL = thisPage + "?cOp=MultiCheckIn";
				layout = LayoutPart.SCHORDERCHECKINLAYOUT;
			}
			else if ( "CheckOut".equals( parOperOrig ) ) {
				editURL = thisPage + "?cOp=CheckOut";
				layout = LayoutPart.SCHORDERCHECKOUTLAYOUT;
			}
			else if ( "Cancel".equals( parOperOrig ) ) {
				editURL = thisPage + "?cOp=Cancel";
				layout = LayoutPart.SCHORDERCANCELLAYOUT;
			}
			if ( !parOper.startsWith( "SaveNew" ) ) {
				if ( !Validator.doValidation( is, layout, dblds, editURL, null ) ) {
					return;
				}
			}
		}

		SchedulerInterface.setLastModified( saveEntry, "0ZMT" );

		Set<FieldInstancePointer> changedFIPs = saveEntry.commit();

		String orderID = saveEntry.getRootRecord().m_rowID.get( 0 );

		Map<String[], String[]> formData = new HashMap<String[], String[]>();
		GregorianCalendar cal = new GregorianCalendar();
		SchedulerInterface.setColumn( formData, orderTable, orderID, "0ZVE", Helper.calcDayTimeStr( cal ) );
		dblds.applyFormData( formData );

		int PACSMode = OrderImport.UPDATE_ORDER;
		Properties logFields = new Properties();
		if ( "Yes".equals( request.getParameter( "isNew" ) ) ) {
			if ( "NewCorrection".equals( parOperOrig ) ) {
				logFields.setProperty( "0LAC", "CreateCorrection" );
			}
			else {
				logFields.setProperty( "0LAC", "Create" );
			}
			PACSMode = OrderImport.NEW_ORDER;
		}
		else if ( "CheckIn2".equals( parOperOrig ) || "MultiCheckIn".equals( parOperOrig ) ) {
			logFields.setProperty( "0LAC", "Check In" );
		}
		else if ( "CheckOut".equals( parOperOrig ) ) {
			logFields.setProperty( "0LAC", "Check Out" );
		}
		else if ( "Cancel".equals( parOperOrig ) ) {
			logFields.setProperty( "0LAC", "Cancel" );
		}
		else if ( "SaveAll".equals( parOper ) ) {
			logFields.setProperty( "0LAC", "Edit Blocks by Group" );
		}
		else {
			logFields.setProperty( "0LAC", "Edit" );
		}

		SchedulerInterface.logChangedFields( changedFIPs, logFields, saveEntry );
		SchedulerInterface.makeLogFieldsFromOrder( is, orderID, logFields );
		SchedulerInterface.logIntoTable( is, logFields );

		if ( !parOper.startsWith( "SaveNew" ) ) {
			Validator.makeLogs( is, dblds, layout );
		}

		//if undeleted now, count attachments
		boolean isUndeleted = "no".equals( saveEntry.getRootRecord().getCurrentValue( "0ZDL", "" ) ) &&
				"yes".equals( saveEntry.getRootRecord().getOldValue( "0ZDL", "" ) );


		boolean isBlock = "yes".equals( saveEntry.getRootRecord().getCurrentValue( "0ZBL", "no" ) );
		if ( isBlock ) {
			if ( "SaveAll".equals( parOper ) ) {
				String groupID = saveEntry.getRootRecord().getCurrentValue( "0ZGR", "" );
				String groupDateTime[] = IMTypeDA_TM.parseDateTime( groupID );
				Statement st = IMEnv.getDB().createStatement();
				String update = "update " + orderTable + " set ";

				boolean foundInBlock = false;
				for ( Iterator<FieldInstancePointer> i = changedFIPs.iterator(); i.hasNext(); ) {
					FieldInstancePointer fip = i.next();
					String colid = fip.m_sfieldID;
					if ( colid != null ) {
						String fieldValue = saveEntry.getRootRecord().getCurrentValue( colid, "" );
						if ( foundInBlock ) {
							update += " , ";
						}
						update += IMBaseFieldManager.DEFAULTFIELDMANAGER.createUpdateClause( colid, fieldValue );
						//						update += IMBaseFieldManager.staticGetDbName( colid ) + " = '" + fieldValue + "'";
						foundInBlock = true;
					}
				}

				if ( foundInBlock ) {
					update += " where concat(" + IMBaseFieldManager.staticGetDbName( "0ZGR" ) + ") = " + "'" + groupDateTime[ 0 ] + groupDateTime[ 1 ] + "'";

					Helper.DEBUG( "Block update:" + update );
					st.executeUpdate( update );
				}
			}
		}
		else {
			//if undeleted now, send new
			if ( isUndeleted ) {
				SchedulerInterface.sendOrderMessageToPacs( OrderImport.NEW_ORDER, orderID, is );
			}
			else {
				//if status correct->incorrect, send cancel
				//if new/status incorrect->correct, send new
				//update only if status is correct

				String oldStatus = saveEntry.getRootRecord().getOldValue( "0ZST", "" );
				String newStatus = saveEntry.getRootRecord().getCurrentValue( "0ZST", "" );
				boolean oldStatusCorrect = SchedulerInterface.checkStatusToPACS( oldStatus );
				boolean newStatusCorrect = SchedulerInterface.checkStatusToPACS( newStatus );

				//detect if Acc.No. changed
				String oldAccNo = saveEntry.getRootRecord().getOldValue( "0ZAN", "" );
				String newAccNo = saveEntry.getRootRecord().getCurrentValue( "0ZAN", "" );
				if ( !oldAccNo.equals( newAccNo ) ) {
					if ( !"".equals( oldAccNo ) && oldStatusCorrect ) {
						SchedulerInterface.sendOrderMessageToPacs( OrderImport.CANCEL_ORDER, orderID, is, oldAccNo );
					}
					if ( !"".equals( newAccNo ) && newStatusCorrect ) {
						if ( "NewCorrection".equals( parOperOrig ) ) {
							SchedulerInterface.sendOrderMessageToPacs( OrderImport.NEW_ORDER, orderID, is, null, true );
						}
						else {
							SchedulerInterface.sendOrderMessageToPacs( OrderImport.NEW_ORDER, orderID, is );
						}
					}
				}
				else {
					if ( PACSMode == OrderImport.UPDATE_ORDER && oldStatusCorrect && !newStatusCorrect ) {
						SchedulerInterface.sendOrderMessageToPacs( OrderImport.CANCEL_ORDER, orderID, is, newAccNo );
					}
					else if ( ( ( PACSMode == OrderImport.NEW_ORDER ) || !oldStatusCorrect ) && newStatusCorrect ) {
						if ( "NewCorrection".equals( parOperOrig ) ) {
							SchedulerInterface.sendOrderMessageToPacs( OrderImport.NEW_ORDER, orderID, is, null, true );
						}
						else {
							SchedulerInterface.sendOrderMessageToPacs( OrderImport.NEW_ORDER, orderID, is );
						}
					}
					else if ( newStatusCorrect ) {
						if ( "NewCorrection".equals( parOperOrig ) ) {
							SchedulerInterface.sendOrderMessageToPacs( OrderImport.NEW_ORDER, orderID, is, null, true );
						}
						else {
							//if it was cancelled, and now isn't, it's 'new' for the PACS
							if ( IMTypeos.STATE_CANCELLED.equals( oldStatus ) &&
									!IMTypeos.STATE_CANCELLED.equals( newStatus ) ) {
								PACSMode = OrderImport.NEW_ORDER;
							}
							SchedulerInterface.sendOrderMessageToPacs( PACSMode, orderID, is );
						}
					}
				}
			}
		}

		if ( isUndeleted ) {
			AttachmentManager.setAttachmentCounts( orderID, false );
		}

		//unlock
		IMLock.lockDBItem( is, orderTable, orderID, "Unlock", new Properties() );

		//redirecting
		if ( "NewCorrection".equals( parOperOrig ) ) {
%><script language="JavaScript">
			document.location="/scheduler/correctiondone.jsp?OrderSelect=Apply&cContext=<%=context%>";
</script><%
			return;
		}
		else if ( "CheckIn2".equals( parOperOrig ) ) {
			if ( SchedulerInterface.generateOtherCheckInOrders( is, orderID, dblds.getValue( "0ZPI" ), dblds.getValue( "0ZSS" ) ) ) {
				return;
			}
			else {
				if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
						document.location="<%=parBack%>";
</script><%
					return;
				}
			}
		}
		else if ( "MultiCheckIn".equals( parOperOrig ) ) {
			if ( otherIDs != null && otherIDs.length > 0 ) {
				String redir = thisPage + "?cOp=MultiCheckIn&cBack=" + Helper.URLEncodeUTF8( parBack );
				boolean first = true;
				for ( int i = 0; i < otherIDs.length; i++ ) {
					if ( first ) {
						first = false;
						redir += "&c0ZID=" + otherIDs[ i ];
					}
					else {
						redir += "&cOtherIDs=" + otherIDs[ i ];
					}
				}
%><script language="JavaScript">
					document.location="<%=redir%>";
</script><%
				return;
			}
			else {
				if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
						document.location="<%=parBack%>";
</script><%
					return;
				}
			}
		}
		else if ( "Save".equals( parOper ) || "SaveAll".equals( parOper ) ) {
			if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
				document.location="<%=parBack%>";
</script><%
//				response.sendRedirect(parBack);
				return;
			}
		}
		else if ( "SaveAndCreateClone".equals( parOper ) ) {
			//edit page with this order ID but with cloning!
			String redir = thisPage;
			redir += "?cOp=EditClone&c0ZID=" + orderID;
			if ( parBack != null && parBack.length() > 0 ) {
				redir += "&cBack=" + Helper.URLEncodeUTF8( parBack );
			}
%><script language="JavaScript">
			document.location="<%=redir%>";
</script><%
			return;
		}
		else if ( "SaveAndNext".equals( parOper ) || "SaveAndPrev".equals( parOper ) ) {
			String[] prevNext = result.findRow( orderID );

			String redir = thisPage;
			if ( "SaveAndNext".equals( parOper ) && prevNext != null && prevNext.length >= 2 && prevNext[ 1 ] != null ) {
				redir += "?cOp=Edit&c0ZID=" + prevNext[ 1 ];
				if ( parBack != null && parBack.length() > 0 ) {
					redir += "&cBack=" + Helper.URLEncodeUTF8( parBack );
				}
			}
			else if ( "SaveAndPrev".equals( parOper ) && prevNext != null && prevNext[ 0 ] != null ) {
				redir += "?cOp=Edit&c0ZID=" + prevNext[ 0 ];
				if ( parBack != null && parBack.length() > 0 ) {
					redir += "&cBack=" + Helper.URLEncodeUTF8( parBack );
				}
			}
			else {
				if ( parBack != null && parBack.length() > 0 ) {
					redir = parBack;
				}
			}
%><script language="JavaScript">
			document.location="<%=redir%>";
</script><%
			return;
		}
		else { //SaveAndSchedule
			String redir = indexPage;
			if ( parBack != null ) {
				String backContext = SchedulerInterface.getContextFromBack( parBack );
				if ( backContext != null ) {
					//modify context to this patient ID only	
					DBLayoutDataSource dbtemp = new DBLayoutDataSource( is, null, orderTable, "0ZID", orderID );
					dbtemp.addJoinTable( orderTable, patientTable, "0ZPI" );
					String PatientID = dbtemp.getValue( new FieldPointer( patientTable, "0UPI" ) );
					if ( PatientID != null ) {
						IMProperties.setValueInFile( reqPar.getContextFileName( backContext ), "qf_0UPI", PatientID );
					}
					redir += "?cContext=" + backContext;
				}
			}
%><script language="JavaScript">
			document.location="<%=redir%>";
</script><%
//			response.sendRedirect( redir );
			return;
		}
	}
%>
<CENTER>
<%
	table.printTableTop( is );
	table.print( is );
%>
</CENTER>
<%= ListSaveForm.getListSaveForm( ListDescriptor.LIST_SCHEDULERORDERSFILTER, is, tdesc ) %>

</BODY>
</HTML>