<%@
	page import="imagemed.util.*,imagemed.imsession.*"
%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"
%>

<%
	IMSession is = new IMSession(request, response, out);
	is.setNonCacheable();
	
	String type = is.request.getParameter("type");
	String id = is.request.getParameter("id");
	String name = is.request.getParameter("name");
	String generic = is.request.getParameter("cGeneric");
	String savename = is.request.getParameter("savename");
	
	String thisPage = "/scheduler/browseupload.jsp";
	String uploadPage = "/scheduler/upload.jsp";

	Helper.DEBUG( "Uploading:Browseupload.jsp", "Called" );
	Helper.DEBUG( "Uploading:Browseupload.jsp", "Type:" + type + " ID:" + id + " Name:" + name );
	
	String ct = is.request.getHeader("content-type");
	if (ct != null && ct.toLowerCase().startsWith("multipart")) {
		//save
		MultipartRequest mp = new MultipartRequest( is, AttachmentManager.getTempDir() );
		String tmpFileName = mp.getParameter("userfile");
		
		Helper.DEBUG( "BrowseUpload", "Not Overwrite, tmpfilename:" + tmpFileName );

		String fileName = mp.getFileNameFor("userfile");
		type = mp.getParameter("type");
		id = mp.getParameter("id");
		name = mp.getParameter("name");
		savename = mp.getParameter("savename");
		generic = mp.getParameter("cGeneric");
		if( savename != null && fileName != null ) {
			if( savename.indexOf('.') == -1 ) {
				//no extension
				int extIndex = fileName.lastIndexOf(".");
				if( extIndex != -1 ) {
					String ext = fileName.substring( extIndex ); //'.' included
					savename += ext;
				}
			}
		}

		if( savename == null ) {
			savename = "";
		}
		
		boolean tried = false;
		boolean success = false;
		if( !"".equals(savename) ) {
			tried = true;
			success = !AttachmentManager.existsGeneric( type, id, savename );
		}
		else if( name != null && !"".equals(name) ) {
			tried = true;
			success = !AttachmentManager.exists( type, id, name );
		}
		if( tried ) {
			if( success ) {
				response.sendRedirect( uploadPage + "?cOverWrite=true&type=" + type + "&id=" + id + "&name=" + name + "&savename=" + savename + "&tmpFileName=" + tmpFileName );
				return;
			}
			else {
				is.out.println( "<HTML><HEAD><TITLE>" + LocalizedMessage.getSimpleMessage( "SCHEDULER_BROWSEUPLOAD" ) + "</TITLE></HEAD>" );
				
				TabBean.writeStyleOnly( is );
				Table.printCommonScript( is );

				is.out.println( "<BODY>" );
				is.out.println( LocalizedMessage.getSimpleMessage( "EXCEPTION_SCHEDULER_BROWSEUPLOAD_ATTACHMENT_FILENAME" ) );
				is.out.println( "<BR><BR><A HREF=\"" + uploadPage + "?cOverWrite=true&tmpFileName=" + tmpFileName + "&name=" + name + "&type=" + type + "&id=" + id + "&savename=" + savename + "\">" );
				is.out.println( JSHelper.getJsLocalizedButton( "BUTTON_SAVE", "BUTTON_SAVE", false) );
				is.out.println( "</A>" );

				if( "yes".equals( generic ) ) {
					is.out.println( "<A HREF=\"" + thisPage + "?name=" + name + "&type=" + type + "&id=" + id + "&cGeneric=" + generic + "\">" );
					is.out.println( JSHelper.getJsLocalizedButton( "BUTTON_SAVE_AS", "BUTTON_SAVE_AS", false ) );
					is.out.println( "</A>" );
				}

				is.out.println( "&nbsp;<A HREF='#' onClick=\"window.close(); return false;\"> "); 
				is.out.println( JSHelper.getJsLocalizedButton( "BUTTON_SAVE", "BUTTON_SAVE", false ) );
				is.out.println( "</A>" );
				
				is.out.println( "</BODY></HTML>" );
				return;
			}
		}
		else {
			is.out.println( LocalizedMessage.getSimpleMessage( "EXCEPTION_SCHEDULER_BROWSEUPLOAD_ATTACHMENT_NO_FILENAME" ) );
		}
	}
	

%>

<%@page import="imagemed.jsputil.AttachmentManager"%>
<%@page import="imagemed.http.tabs.TabBean"%>
<%@page import="imagemed.tables.Table"%>
<HTML>
<HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "SCHEDULER_BROWSEUPLOAD" ) %></TITLE>
<%	imagemed.http.tabs.TabBean.writeStyleOnly(is);%>
</HEAD>
<BODY>

<table width="100%" border=1 cellpadding=0 cellspacing=0 class=BgShadow>
	<tr>
		<td>
			<br>
			&nbsp;&nbsp;<font size="4"><%= LocalizedMessage.getSimpleMessage( "SCHEDULER_BROWSEUPLOAD_UPLOADING_ATTACHMENTS" ) %></font>
			<br> &nbsp;
		</td>
	</tr>
</table>
<SCRIPT language="Javascript">
	function convertname( str )	{
		lastslash = str.lastIndexOf("/");
		lastbackslash = str.lastIndexOf("\\");
		if( lastslash == -1 && lastbackslash == -1 ) {
			return str;
		}
		else {
			if( lastbackslash > lastslash ) {
				return str.substr( lastbackslash + 1 );
			}
			else {
				return str.substr( lastslash + 1 );
			}				
		}
	}
	

  function checkForm()
  {
   if (document.forms[0].userfile.value=='')
   {
      document.forms[0].userfile.focus();
      alert( "<%= LocalizedMessage.getSimpleMessage( "EXCEPTION_SCHEDULER_BROWSEUPLOAD_SELECT_FILE_ALERT" ) %>" );
      return false;
   }
   else if (document.forms[0].savename.value=='')
   {
      document.forms[0].savename.focus();
      alert( " <%= LocalizedMessage.getSimpleMessage( "EXCEPTION_SCHEDULER_BROWSEUPLOAD_FILENAME_ALERT" ) %>s" );
      return false;
   }
   else if (document.forms[0].savename.value.indexOf("/") != -1 || document.forms[0].savename.value.indexOf("\\") != -1 )
   {
      document.forms[0].savename.focus();
      alert( " <%= LocalizedMessage.getSimpleMessage( "EXCEPTION_SCHEDULER_BROWSEUPLOAD_SAVE_AS_ALERT" ) %>" );
      return false;
   }
   else {
      return true;
   }
  }
</SCRIPT>
<table width="100%" border=1 cellpadding=0 cellspacing=0 class=BgShadow>
	<tr>
		<td align="center">
			<form action=browseupload.jsp onSubmit="return checkForm();" method=post enctype=multipart/form-data>
				<input type=hidden name="type" value="<%= type %>">
				<input type=hidden name="id" value="<%= id %>">
				<input type=hidden name="cGeneric" value="<%= generic %>">
<%
	if( "yes".equals( generic ) ) {
%>
				<input type=file name=userfile size=48 onchange="savename.value=convertname(this.value)">
				<%= LocalizedMessage.getSimpleMessage( "SCHEDULER_BROWSEUPLOAD_SAVE_AS" ) %>:&nbsp;
				<input type=text name="savename" >
<%
	} 
	else {
%>
				<input type=file name=userfile>
				<input type=hidden name="name" value="<%= name %>">
<%
	}
%>
				<input type=submit value=Upload>
			</form>
		</td>
	</tr>
</TABLE>

</BODY>
	
</HTML>
