<%@
	page import="
			java.util.*,

			imagemed.http.IMRequest,
			imagemed.imsession.*,
			imagemed.imtables.*,
			imagemed.jsputil.*,
			imagemed.layout.*,
			imagemed.layout.datasource.*,
			imagemed.layout.datasource.pointer.FieldInstancePointer,
			imagemed.layout.macro.button.RecordButtonMacro,
			imagemed.layout.validator.Validator,
			imagemed.lists.*,
			imagemed.scheduler.SchedulerInterface,
			imagemed.tables.*,
			imagemed.types.flag.IMTypeur,
			imagemed.util.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	static String thisPage = "/scheduler/referrers.jsp";
	static String orderPage = "/scheduler/orders.jsp";

%><%

	IMSession is = new IMSession( request, response, out );

	if ( !is.regOK() ) {
		return;
	}

	String parOper = is.getButtonParam( "cOp" );
	String parOperOrig = is.getButtonParam( "cOpOrig" );
	String parOrderFieldName = is.getButtonParam( "cOrderFieldName" );
	String parOrderEntryName = is.getButtonParam( "cOrderEntryName" );
	String parBack = request.getParameter( "cBack" );
	IMRequest reqPar = is.imRequest;
	String parReferrer = reqPar.getVal( "c0XID" );
	String context = reqPar.m_context;
	boolean isSeeDeleted = "true".equals( is.imRequest.digUpVal( "cSeeDeleted", "" ) );
	//	boolean hasSupportRights = is.regRights != null && -1 != is.regRights.indexOf('@');
	boolean hasAdminRights = is.hasRight( IMTypeur.ADMIN_RIGHT );
	boolean hasCreateEditRights = is.hasRight( IMTypeur.SCHEDULER_CREATE_EDIT_REFERRER_RIGHT );

	if ( !Table.isExporting( is ) ) {
		is.setNonCacheable();
		if ( parOper == null ) {
			if ( context == null || context.length() == 0 ) {
				context = reqPar.backupContext();
				// we did not have a context, redirect the page now.
				response.sendRedirect( thisPage + "?cContext=" + context );
				return;
			}
			else {
				// just save the context
				reqPar.passAsFile( context );
			}
		}
	}

	DBLayoutDataSource dblds = EntryLayoutFactory.getDefaultDBLDS( is, LayoutPart.SCHREFERRERLAYOUT );

	FieldManager fm = EntryLayoutFactory.getDefaultFieldManager( is, LayoutPart.SCHREFERRERLAYOUT );

	String referrerTable = IMEnvBase.getEnv( "SCHEDULERREFERRERTBL" );

	// --- Init Table without Result ---

	String thisPageMenuTab = "scheduler/tables.jsp";

	TableDescriptor tdesc = new TableDescriptor( thisPage, true, true, true, false );
	TableProperties tprop = new TableProperties();

	boolean isNextPrev = false;
	if ( "SaveAndNext".equals( parOper ) ||
			"SaveAndPrev".equals( parOper ) ||
			"ViewNext".equals( parOper ) ||
			"ViewPrev".equals( parOper ) ) {
		isNextPrev = true;
		if ( context == null ) {
			context = SchedulerInterface.getContextFromBack( parBack );
		}
		if ( context != null ) {
			is.imRequest.m_context = context;
			is.imRequest.mergeContext( thisPage );
		}
	}

	WorklistTableParams tparams = new WorklistTableParams( is, is.getProfileUser(), is.regRights.indexOf( 'A' ) > -1, is.isRegisteredViewer() );
	tparams.setDefaults( thisPage, is );

	tdesc.setFieldManager( fm );
	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );
	tdesc.setSortDepth( 3 );

	if ( isNextPrev ) {
		tparams.setPageSize( -1 );
	}

	List<Action> act = new ArrayList<Action>();
	act.add( new LinkAction( tdesc, "0XID", "javascript:redirPage_b(\"referrers.jsp?c0XID=$$0XID$$&cOp=View\")",
			"<script language=\"JavaScript\">getImage(\'qview\', 18, 20, \' alt=\"" + LocalizedMessage.getSimpleMessage( "VIEW_SCHEDULER_REFERRING_PHYSICIAN" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "VIEW_SCHEDULER_REFERRING_PHYSICIAN" ) + "\"\');</script>",
			LocalizedMessage.getSimpleMessage( "VIEW_SCHEDULER_REFERRING_PHYSICIAN" ) ) );

	if ( hasCreateEditRights ) {
		act.add( new LinkAction( tdesc, "0XID", "javascript:redirPage_b(\"referrers.jsp?c0XID=$$0XID$$&cOp=Edit\")",
				"<script language=\"JavaScript\">getImage(\'edit\', 18, 20, \' alt=\"" + LocalizedMessage.getSimpleMessage( "EDIT_SCHEDULER_REFERRING_PHYSICIAN" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "EDIT_SCHEDULER_REFERRING_PHYSICIAN" ) + "\"\');</script>",
				LocalizedMessage.getSimpleMessage( "EDIT_SCHEDULER_REFERRING_PHYSICIAN" ) ) );
	}

	if ( hasAdminRights ) {
		act.add( new ConditionalLinkAction( tdesc, "0XID", "javascript:redirPage_b(\"referrers.jsp?c0XID=$$0XID$$&cOp=Delete\")",
				"delete", "18", "20", LocalizedMessage.getSimpleMessage( "DELETE_SCHEDULER_REFERRING_PHYSICIAN" ), LocalizedMessage.getSimpleMessage( "DELETE_SCHEDULER_REFERRING_PHYSICIAN" ) ) {

			@Override
			public boolean isButtonThere( IMSession _is, Result result ) {
				String deletedStr = result.getValue( "0XDE", "no" );
				return ( "no".equals( deletedStr ) );
			}
		} );
	}

	Column col = new Column( new SimpleHeader( "&nbsp;" ), new ActionCell( "0XID", new Action[]{ new MultiAction( tprop, act.toArray( new Action[ 0 ] ) ) } ), "0XID" );
	tdesc.addExtraColumn( "_FIRST", col );

	List<TopCell> topCell = new ArrayList<TopCell>();

	TitleTopCell title = new TitleTopCell( tprop, LocalizedMessage.getSimpleMessage( "SCHEDULER_REFERRING_PHYSICIAN" ) );
	title.clearWidth();

	topCell.add( title );

	topCell.add( new ListsTopCell( ListDescriptor.LIST_SCHEDULERREFERRERSFILTER, tdesc, is.getProfileUser(), true ) );

	if ( hasCreateEditRights ) {
		topCell.add( new SimpleTopCell( tprop,
				JSHelper.getJsButtonSLink( is, "javascript:redirPage_b('referrers.jsp?cOp=New')", "newButton", 0, 0, LocalizedMessage.getSimpleMessage( "ALT_TEXT_ADD_PHYSICIAN" ) ) ) );
		topCell.add( new SeparatorTopCell( tprop, 4 ) );
	}

	topCell.add( new FieldsTopCell( tdesc, null, true ) );
	topCell.add( new FiltersTopCell( tdesc, null, false, new String[ 0 ], true ) );
	topCell.add( new SortsTopCell( tdesc, null, false, true ) );

	if ( hasAdminRights ) {
		topCell.add( new SeparatorTopCell( tprop, 4 ) );
		topCell.add( new SeeDeletedTopCell( tdesc ) );
	}

	topCell.add( new PageTopCell( tprop, tparams ) );
	tdesc.setTopCells( topCell );

	// --- Init Table with Result ---
	if ( Table.isExporting( is ) ) {
		tparams.setPageSize( 0 );
	}

	DBLDSWrapperNatSqlResult result = new DBLDSWrapperNatSqlResult( tdesc, dblds, !isSeeDeleted );
	result.setRequiredFields( new String[]{ "0XDE" } );

	tdesc.setResult( result );
	Table table = new Table( tdesc );
	table.setImportable( true );

	if ( table.handleExport( is ) ) {
		return;
	}

%><%-- --- HTML --- --%><HTML>
<HEAD><TITLE><%=LocalizedMessage.getSimpleMessage( "SCHEDULER_REFERRING_PHYSICIAN" )%></TITLE>
 <SCRIPT Language="JavaScript">
 	var pageContext="<%=context%>";
 </script>
<%
	TabToolbox.writeIMpopup( is.out );
	table.printScript( tparams, is );
	JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
%>
  <SCRIPT language="JavaScript">
		function doSubmit(frm, mod) {
			while (frm.cOp.value != mod) {
				frm.cOp.value=mod;
			}
			frm.submit();
		}


  </script>
</head>

<BODY>
<%
	TabToolbox.makeTabs( is, is.tabbean, thisPageMenuTab, "White" );
	// --- Oper ---

	if ( "View".equals( parOper ) || "New".equals( parOper ) || "Edit".equals( parOper ) || "Refresh".equals( parOper ) || "NewBackToOrder".equals( parOper ) || ( parOper != null && parOper.startsWith( "Record" ) ) ) {
		if ( "View".equals( parOper ) || "New".equals( parOper ) || "Edit".equals( parOper ) || "Refresh".equals( parOper ) || "NewBackToOrder".equals( parOper ) ) {
			parOperOrig = parOper;
		}

		SchedulerInterface.putLabel( is, "SCHEDULER_REFERRING_PHYSICIAN", parOperOrig );

		boolean isEdit = !"View".equals( parOper );
		DBLDSEntry entry = null;
		String entryName = request.getParameter( "cEntryName" );
		if ( entryName != null ) {
			entry = DBLDSEntry.readFile( is, entryName, dblds );
			dblds.setEntry( entry );
			entry.initFromRequest( is.imRequest );
			if ( RecordButtonMacro.doRecordOperation( dblds, is ) || "Refresh".equals( parOper ) ) {
				if ( parOperOrig != null ) {
					parOper = parOperOrig;
				}
				else {
					parOper = "Edit";
				}
			}
		}
		else {
			entry = new DBLDSEntry( dblds );
			dblds.setEntry( entry );
			if ( !parOper.startsWith( "New" ) ) {
				entry.initFromExisting( parReferrer );
			}
			else {
				// create a default empty referrer
				entry.addRecord( dblds.getTable(), null ); // root record
			}
		}
		dblds.setRepeatPointer( dblds.getTable(), 0 );
		if ( isEdit ) {
%>
    <FORM action="<%=thisPage%>" method=post name="saveForm" id="saveForm">
			<INPUT type="hidden" name="cBack" value="<%=request.getParameter("cBack")%>">
			<input type=hidden name=cOp value="Save">
			<input type=hidden name=cOpOrig value="<%=parOperOrig%>">
<%
			if ( parOper.startsWith( "New" ) ||
					"Yes".equals( request.getParameter( "isNew" ) ) ) {
%>
				<input type=hidden name=isNew value="Yes">
<%
			}
			if ( "NewBackToOrder".equals( parOper ) ||
					"NewBackToOrder".equals( parOperOrig ) ) {
%>
				<input type=hidden name=cOrderEntryName value=<%=request.getParameter("cOrderEntryName")%>>
				<input type=hidden name=cOrderFieldName value=<%=request.getParameter("cOrderFieldName")%>>
<%
			}
		}
		else if ( "View".equals( parOper ) ) {
%>
	    <FORM action="<%=thisPage%>" method=post name="saveForm" id="saveForm">
				<INPUT type="hidden" name="cBack" value="<%=request.getParameter("cBack")%>">
				<input type=hidden name=cOp value="View">
				<input type=hidden name=c0XID value="<%=parReferrer%>">
			</FORM>
<%
		}

		OperatingMode mode = "View".equals( parOper ) ? LayoutPart.VIEWING : LayoutPart.EDITING;
		LayoutRoot root = imagemed.layout.cache.LayoutCache.getSystemLayout( is, LayoutPart.SCHREFERRERLAYOUT );
		String html = root.getHtml( "  " + ( "View".equals( parOper ) ? "" : "  " ), mode, dblds );

		out.println( html );
		if ( isEdit ) {
			String savedName = LDSEntry.writeFile( is, entry );
%>
			<input type=hidden name=cEntryName id=cEntryName value="<%=savedName%>">
</FORM>
<%
		}
%>
</body>
</html>
<%
		return;
	}
	else if ( "SeeValidator".equals( parOper ) ) {
		String parLayout = reqPar.getVal( "cLayout" );
		DBLDSEntry entry = new DBLDSEntry( dblds );
		dblds.setEntry( entry );
		entry.initFromExisting( parReferrer );
		is.imRequest.setProperty( "cDisplayType", "FromList" );
		if ( Validator.doValidation( is, parLayout, dblds, null, null ) ) {
			if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
				document.location="<%=parBack%>";
</script><%
				return;
			}
		}
		else {
			return;
		}
	}
	else if ( "Delete".equals( parOper ) ) {
%>
  	<FORM name="operForm" method="POST" action="<%=thisPage%>">
  		<CENTER>
	  	<H2><P>&nbsp;
			<P><%=LocalizedMessage.getSimpleMessage( "SCHEDULER_REFERRING_PHYSICIAN_DELETE_MSG" )%>
			<P>
			<input type=hidden name="c0XID" value="<%=parReferrer%>">
			<input type=hidden name="cBack" value="<%=parBack%>">
			<%=JSHelper.getJsInputLocalizedButton( is, "BUTTON_DELETE", "cOp", "DeleteSure" )%>
			&nbsp; &nbsp; &nbsp; &nbsp;
			<a href="<%=parBack%>"><%=JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false )%></a>
			</H2>
  		</CENTER>
		</FORM>
</body>
</html>
<%
		return;
	}
	else if ( "DeleteSure".equals( parOper ) ) {
		if ( !"true".equals( is.imRequest.digUpVal( "cIgnoreWarns", "" ) ) ) {
			DBLDSEntry entry = new DBLDSEntry( dblds );
			dblds.setEntry( entry );
			entry.initFromExisting( parReferrer );

			if ( !Validator.doDeleteValidation( is, LayoutPart.SCHREFERRERLAYOUT, dblds, null ) ) {
				// form with errors or warnings displayed...
				return;
			}
		}


		Properties logFields = new Properties();
		logFields.setProperty( "0LAC", "Delete" );
		SchedulerInterface.makeLogFieldsFromReferrer( is, parReferrer, logFields );
		SchedulerInterface.logIntoTable( is, logFields );

		//BTS9312  			SchedulerInterface.setNewAdminVersion();

		SchedulerInterface.deleteRecord( referrerTable, "0XID", parReferrer );

		if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
			document.location="<%=parBack%>";
</script><%
//			response.sendRedirect( parBack );
			return;
		}
	}
	else if ( "ViewNext".equals( parOper ) || "ViewPrev".equals( parOper ) ) {
		String[] prevNext = result.findRow( parReferrer );

		String redir = thisPage;
		if ( "ViewNext".equals( parOper ) && prevNext != null && prevNext.length >= 2 && prevNext[ 1 ] != null ) {
			redir += "?cOp=View&c0XID=" + prevNext[ 1 ];
			if ( parBack != null && parBack.length() > 0 ) {
				redir += "&cBack=" + Helper.URLEncodeUTF8( parBack );
			}
		}
		else if ( "ViewPrev".equals( parOper ) && prevNext != null && prevNext[ 0 ] != null ) {
			redir += "?cOp=View&c0XID=" + prevNext[ 0 ];
			if ( parBack != null && parBack.length() > 0 ) {
				redir += "&cBack=" + Helper.URLEncodeUTF8( parBack );
			}
		}
		else {
			if ( parBack != null && parBack.length() > 0 ) {
				redir = parBack;
			}
		}
%><script language="JavaScript">
		document.location="<%=redir%>";
</script><%
		return;
	}

	else if ( parOper != null && parOper.startsWith( "Save" ) ) {
		// 
		DBLDSEntry entry = DBLDSEntry.readFile( is, request.getParameter( "cEntryName" ), dblds );
		dblds.setEntry( entry );
		entry.initFromRequest( is.imRequest );

		if ( "NewBackToOrder".equals( parOperOrig ) ) {
			String params = "&cOrderEntryName=" + parOrderEntryName + "&cOrderFieldName=" + Helper.URLEncodeUTF8( parOrderFieldName );
			String editURL = thisPage + "?cOp=NewBackToOrder" + params;
			String saveURL = thisPage + "?cOp=Save" + params;
			//cBack will be added by validator
			if ( !Validator.doValidation( is, LayoutPart.SCHREFERRERLAYOUT, dblds, editURL, saveURL ) ) {
				// form with errors or warnings displayed...
				return;
			}
		}
		else {
			if ( !Validator.doValidation( is, LayoutPart.SCHREFERRERLAYOUT, dblds, null, null ) ) {
				// form with errors or warnings displayed...
				return;
			}
		}

		Set<FieldInstancePointer> changedFIPs = entry.commit();

		Properties logFields = new Properties();
		if ( "Yes".equals( request.getParameter( "isNew" ) ) ) {
			logFields.setProperty( "0LAC", "Create" );
		}
		else {
			logFields.setProperty( "0LAC", "Edit" );
			//TODO: get changed fields
		}
		String referrerID = entry.getRootRecord().m_rowID.get( 0 );
		SchedulerInterface.logChangedFields( changedFIPs, logFields, entry );
		SchedulerInterface.makeLogFieldsFromReferrer( is, referrerID, logFields );
		SchedulerInterface.logIntoTable( is, logFields );

		Validator.makeLogs( is, dblds, LayoutPart.SCHREFERRERLAYOUT );

		//BTS9312		SchedulerInterface.setNewAdminVersion();

		//redirect
		if ( "NewBackToOrder".equals( parOperOrig ) ) {
			DBLayoutDataSource orderDblds = EntryLayoutFactory.getDefaultDBLDS( is, LayoutPart.SCHORDERLAYOUT );
			DBLDSEntry orderEntry = DBLDSEntry.readFile( is, parOrderEntryName, orderDblds );
			FieldInstancePointer fip = FieldInstancePointer.decomposeFormInputName( parOrderFieldName );
			LDSRecord orderRec = orderEntry.getRecord( IMEnvBase.getEnv( "SCHEDULERORDERREFERRERTBL" ), fip.m_rowIDs );
			orderRec.setValue( fip.m_sfieldID, referrerID );
			LDSEntry.writeFile( is, orderEntry );
%><script language="JavaScript">
			document.location="<%=parBack%>";
</script><%
			return;
		}
		else if ( "SaveAndNext".equals( parOper ) || "SaveAndPrev".equals( parOper ) ) {
			String[] prevNext = result.findRow( referrerID );

			String redir = thisPage;
			if ( "SaveAndNext".equals( parOper ) && prevNext != null && prevNext.length >= 2 && prevNext[ 1 ] != null ) {
				redir += "?cOp=Edit&c0XID=" + prevNext[ 1 ];
				if ( parBack != null && parBack.length() > 0 ) {
					redir += "&cBack=" + Helper.URLEncodeUTF8( parBack );
				}
			}
			else if ( "SaveAndPrev".equals( parOper ) && prevNext != null && prevNext[ 0 ] != null ) {
				redir += "?cOp=Edit&c0XID=" + prevNext[ 0 ];
				if ( parBack != null && parBack.length() > 0 ) {
					redir += "&cBack=" + Helper.URLEncodeUTF8( parBack );
				}
			}
			else {
				if ( parBack != null && parBack.length() > 0 ) {
					redir = parBack;
				}
			}
%><script language="JavaScript">
			document.location="<%=redir%>";
</script><%
			return;
		}
		else {
			if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
				document.location="<%=parBack%>";
</script><%
				return;
			}
		}
	}
%>
<CENTER>
<%
	table.printTableTop( is );
	table.print( is );
%>
</CENTER>
<%= ListSaveForm.getListSaveForm( ListDescriptor.LIST_SCHEDULERREFERRERSFILTER, is, tdesc ) %>

</BODY>
</HTML>